//+-------------------------------------------------------------------+
//| Pivot_PerDay.mq4                                                  |
//| Copyright  2004, MetaQuotes Software Corp.                       |
//| http://www.metaquotes.net                                         |
//|                                                                   |
//| Modified by Hossein Paydar                                        |
//|                                                                   |
//| You are free to use it                                            |
//|                                                                   |
//|                                                                   |
//+-------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link "http://www.metaquotes.net"


#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 EMPTY


extern bool pivots = true;
extern bool camarilla = false;
extern bool midpivots = true;
extern int MyPeriod = PERIOD_D1;
extern int Days = 60;
/*+----------------------------------------------------+
 MyPeriod = Period in minutes to consideration, could be:
 1440 for D1
 60 for H1
 240 for H4
 1 for M1
 15 for M15
 30 for M30
 5 for M5
 43200 for MN1
 10080 for W1
 +-------------------------------------------------------*/


double day_high=0;
double day_low=0;
double yesterday_high=0;
double yesterday_open=0;
double yesterday_low=0;
double yesterday_close=0;
double day_open=0;
double today_high=0;
double today_low=0;
double P=0;
double Q=0;
double R1,R2,R3;
double M0,M1,M2,M3,M4,M5;
double S1,S2,S3;
double H4,H3,L4,L3;
double nQ=0;
double nD=0;
double D=0;
double rates_d1[2][6];
double rates_h1[2][6];
double ExtMapBuffer1[];
datetime day_date;
int cnt=0;
int cnt2=1;
int sign_pos=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function |
//+------------------------------------------------------------------+
int init()
{
IndicatorBuffers(4);
SetIndexStyle(0,DRAW_ARROW);
SetIndexArrow(0,159);
SetIndexBuffer(0, ExtMapBuffer1);

//---- indicators
R1=0; R2=0; R3=0;
M0=0; M1=0; M2=0; M3=0; M4=0; M5=0;
S1=0; S2=0; S3=0;
H4=0; H3=0; L4=0; L3=0;


//----
return(0);
}
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function |
//+------------------------------------------------------------------+
int deinit()
{
//---- TODO: add your code here
for (cnt=1;cnt<=Days;cnt++)
{
ObjectDelete("R1 Label"+ DoubleToStr(cnt,0));
ObjectDelete("R1 arrow"+ DoubleToStr(cnt,0));
ObjectDelete("R2 Label"+ DoubleToStr(cnt,0));
ObjectDelete("R2 arrow"+ DoubleToStr(cnt,0));
ObjectDelete("R3 Label"+ DoubleToStr(cnt,0));
ObjectDelete("R3 arrow"+ DoubleToStr(cnt,0));
ObjectDelete("S1 Label"+ DoubleToStr(cnt,0));
ObjectDelete("S1 arrow"+ DoubleToStr(cnt,0));
ObjectDelete("S2 Label"+ DoubleToStr(cnt,0));
ObjectDelete("S2 arrow"+ DoubleToStr(cnt,0));
ObjectDelete("S3 Label"+ DoubleToStr(cnt,0));
ObjectDelete("S3 arrow"+ DoubleToStr(cnt,0));
ObjectDelete("P Label"+ DoubleToStr(cnt,0));
ObjectDelete("P arrow"+ DoubleToStr(cnt,0));
ObjectDelete("H4 Label"+ DoubleToStr(cnt,0));
ObjectDelete("H4 arrow"+ DoubleToStr(cnt,0));
ObjectDelete("H3 Label"+ DoubleToStr(cnt,0));
ObjectDelete("H3 arrow"+ DoubleToStr(cnt,0));
ObjectDelete("L3 Label"+ DoubleToStr(cnt,0));
ObjectDelete("L3 arrow"+ DoubleToStr(cnt,0));
ObjectDelete("L4 Label"+ DoubleToStr(cnt,0));
ObjectDelete("L4 arrow"+ DoubleToStr(cnt,0));
ObjectDelete("M5 Label"+ DoubleToStr(cnt,0));
ObjectDelete("M5 arrow"+ DoubleToStr(cnt,0));
ObjectDelete("M4 Label"+ DoubleToStr(cnt,0));
ObjectDelete("M4 arrow"+ DoubleToStr(cnt,0));
ObjectDelete("M3 Label"+ DoubleToStr(cnt,0));
ObjectDelete("M3 arrow"+ DoubleToStr(cnt,0));
ObjectDelete("M2 Label"+ DoubleToStr(cnt,0));
ObjectDelete("M2 arrow"+ DoubleToStr(cnt,0));
ObjectDelete("M1 Label"+ DoubleToStr(cnt,0));
ObjectDelete("M1 arrow"+ DoubleToStr(cnt,0));
ObjectDelete("M0 Label"+ DoubleToStr(cnt,0));
ObjectDelete("M0 arrow"+ DoubleToStr(cnt,0));
}
//----
return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function |
//+------------------------------------------------------------------+
int start()
{

//---- TODO: add your code here

//---- exit if period is greater than daily charts
if(Period() > 1440)
{
Print("Error - Chart period is greater than 1 day.");
return(-1); // then exit
}

//---- Get new daily prices

ArrayCopyRates(rates_d1, Symbol(), MyPeriod);
//ArrayCopyRates(rates_h1, Symbol(), 60);

for (cnt=1;cnt<=Days;cnt++)
{
if(TimeDayOfWeek(rates_d1[cnt-1][0])!=1) 
{
yesterday_close = rates_d1[cnt][4];
yesterday_open = rates_d1[cnt][1];
day_open = rates_d1[cnt-1][1];
yesterday_high = rates_d1[cnt][3];
yesterday_low = rates_d1[cnt][2];
day_high = rates_d1[cnt-1][3];
day_low = rates_d1[cnt-1][2];
if(TimeDayOfWeek(rates_d1[cnt-1][0])!=0) 
{
sign_pos=rates_d1[cnt-1][0]+36000;
}
else
{
sign_pos=rates_d1[cnt-2][0]+36000;
}
Print("day=",TimeDayOfWeek(rates_d1[cnt-1][0]));

//---- Calculate Pivots

D = (day_high - day_low);
Q = (yesterday_high - yesterday_low);
P = (yesterday_high + yesterday_low + yesterday_close) / 3;
R1 = (2*P)-yesterday_low;
S1 = (2*P)-yesterday_high;
R2 = P+(yesterday_high - yesterday_low);
S2 = P-(yesterday_high - yesterday_low);

H4 = (Q*0.55)+yesterday_close;
H3 = (Q*0.27)+yesterday_close;
R3 = (2*P)+(yesterday_high-(2*yesterday_low));
M5 = (R2+R3)/2;
// R2 = P-S1+R1;
M4 = (R1+R2)/2;
// R1 = (2*P)-yesterday_low;
M3 = (P+R1)/2;
// P = (yesterday_high + yesterday_low + yesterday_close)/3;
M2 = (P+S1)/2;
// S1 = (2*P)-yesterday_high;
M1 = (S1+S2)/2;
// S2 = P-R1+S1;
S3 = (2*P)-((2* yesterday_high)-yesterday_low);
L3 = yesterday_close-(Q*0.27);
L4 = yesterday_close-(Q*0.55);
M0 = (S2+S3)/2;

if (Q > 5)
{
nQ = Q;
}
else
{
nQ = Q*10000;
}

if (D > 5)
{
nD = D;
}
else
{
nD = D*10000;
}


Comment("High= ",yesterday_high," Previous DaysRange= ",nQ,"\nLow= ",yesterday_low," Current DaysRange= ",nD,"\nClose= ",yesterday_close);

//---- Set arrow labels on chart window

//---- Pivot arrows
if (pivots==true)
{
ObjectCreate("R1 label"+DoubleToStr(cnt,0), OBJ_TEXT, 0, sign_pos, R1);
ObjectSetText("R1 label"+ DoubleToStr(cnt,0), " R1", 8, "Arial", LimeGreen);
ObjectCreate("R2 label"+ DoubleToStr(cnt,0), OBJ_TEXT, 0, sign_pos, R2);
ObjectSetText("R2 label"+ DoubleToStr(cnt,0), " R2", 8, "Arial", LimeGreen);
ObjectCreate("R3 label"+ DoubleToStr(cnt,0), OBJ_TEXT, 0, sign_pos, R3);
ObjectSetText("R3 label"+ DoubleToStr(cnt,0), " R3", 8, "Arial", LimeGreen);
ObjectCreate("P label"+ DoubleToStr(cnt,0), OBJ_TEXT, 0, sign_pos, P);
ObjectSetText("P label"+ DoubleToStr(cnt,0), "Pivot ", 8, "Arial",Magenta);
ObjectCreate("S1 label"+ DoubleToStr(cnt,0), OBJ_TEXT, 0, sign_pos, S1);
ObjectSetText("S1 label"+ DoubleToStr(cnt,0), "S1", 8, "Arial", Red);
ObjectCreate("S2 label"+ DoubleToStr(cnt,0), OBJ_TEXT, 0, sign_pos, S2);
ObjectSetText("S2 label"+ DoubleToStr(cnt,0), "S2", 8, "Arial", Red);
ObjectCreate("S3 label"+ DoubleToStr(cnt,0), OBJ_TEXT, 0, sign_pos, S3);
ObjectSetText("S3 label"+ DoubleToStr(cnt,0), "S3", 8, "Arial", Red);

//--- Draw Pivot arrows on chart
ObjectCreate("S1 arrow"+ DoubleToStr(cnt,0), OBJ_ARROW, 0, sign_pos, S1);
ObjectSet("S1 arrow"+ DoubleToStr(cnt,0), OBJPROP_ARROWCODE, 6); 
ObjectSet("S1 arrow"+ DoubleToStr(cnt,0), OBJPROP_COLOR, Red);
ObjectCreate("S2 arrow"+ DoubleToStr(cnt,0), OBJ_ARROW, 0, sign_pos, S2);
ObjectSet("S2 arrow"+ DoubleToStr(cnt,0), OBJPROP_ARROWCODE, 6); 
ObjectSet("S2 arrow"+ DoubleToStr(cnt,0), OBJPROP_COLOR, Red);
ObjectCreate("S3 arrow"+ DoubleToStr(cnt,0), OBJ_ARROW, 0, sign_pos, S3);
ObjectSet("S3 arrow"+ DoubleToStr(cnt,0), OBJPROP_ARROWCODE, 6); 
ObjectSet("S3 arrow"+ DoubleToStr(cnt,0), OBJPROP_COLOR, Red);
ObjectCreate("P arrow"+ DoubleToStr(cnt,0), OBJ_ARROW, 0, sign_pos, P);
ObjectSet("P arrow"+ DoubleToStr(cnt,0), OBJPROP_ARROWCODE, 6); 
ObjectSet("P arrow"+ DoubleToStr(cnt,0), OBJPROP_COLOR,Magenta );
ObjectCreate("R1 arrow"+ DoubleToStr(cnt,0), OBJ_ARROW, 0, sign_pos, R1);
ObjectSet("R1 arrow"+ DoubleToStr(cnt,0), OBJPROP_ARROWCODE, 6); 
ObjectSet("R1 arrow"+ DoubleToStr(cnt,0), OBJPROP_COLOR, LimeGreen);
ObjectCreate("R2 arrow"+ DoubleToStr(cnt,0), OBJ_ARROW, 0, sign_pos, R2);
ObjectSet("R2 arrow"+ DoubleToStr(cnt,0), OBJPROP_ARROWCODE, 6); 
ObjectSet("R2 arrow"+ DoubleToStr(cnt,0), OBJPROP_COLOR, LimeGreen);
ObjectCreate("R3 arrow"+ DoubleToStr(cnt,0), OBJ_ARROW, 0, sign_pos, R3);
ObjectSet("R3 arrow"+ DoubleToStr(cnt,0), OBJPROP_ARROWCODE, 6); 
ObjectSet("R3 arrow"+ DoubleToStr(cnt,0), OBJPROP_COLOR, LimeGreen);
}
//---- End of Pivot arrow Draw


//----- Camarilla arrows

if (camarilla==true)
{
ObjectCreate("H4 label"+ DoubleToStr(cnt,0), OBJ_TEXT, 0, sign_pos, H4);
ObjectSetText("H4 label"+ DoubleToStr(cnt,0), " H4", 8, "Arial", Yellow);
ObjectCreate("H3 label"+ DoubleToStr(cnt,0), OBJ_TEXT, 0, sign_pos, H3);
ObjectSetText("H3 label"+ DoubleToStr(cnt,0), " H3", 8, "Arial", Yellow);
ObjectCreate("L3 label"+ DoubleToStr(cnt,0), OBJ_TEXT, 0, sign_pos, L3);
ObjectSetText("L3 label"+ DoubleToStr(cnt,0), " L3", 8, "Arial", Yellow);
ObjectCreate("L4 label"+ DoubleToStr(cnt,0), OBJ_TEXT, 0, sign_pos, L4);
ObjectSetText("L4 label"+ DoubleToStr(cnt,0), " L4", 8, "Arial", Yellow);

//---- Draw Camarilla arrows on Chart
ObjectCreate("H4 arrow"+ DoubleToStr(cnt,0), OBJ_ARROW, 0, sign_pos, H4);
ObjectSet("H4 arrow"+ DoubleToStr(cnt,0), OBJPROP_ARROWCODE, 6); 
ObjectSet("H4 arrow"+ DoubleToStr(cnt,0), OBJPROP_COLOR, Yellow);
ObjectCreate("H3 arrow"+ DoubleToStr(cnt,0), OBJ_ARROW, 0, sign_pos, H3);
ObjectSet("H3 arrow"+ DoubleToStr(cnt,0), OBJPROP_ARROWCODE, 6); 
ObjectSet("H3 arrow"+ DoubleToStr(cnt,0), OBJPROP_COLOR, Yellow);
ObjectCreate("L3 arrow"+ DoubleToStr(cnt,0), OBJ_ARROW, 0, sign_pos, L3);
ObjectSet("L3 arrow"+ DoubleToStr(cnt,0), OBJPROP_ARROWCODE, 6); 
ObjectSet("L3 arrow"+ DoubleToStr(cnt,0), OBJPROP_COLOR, Yellow);
ObjectCreate("L4 arrow"+ DoubleToStr(cnt,0), OBJ_ARROW, 0, sign_pos, L4);
ObjectSet("L4 arrow"+ DoubleToStr(cnt,0), OBJPROP_ARROWCODE, 6); 
ObjectSet("L4 arrow"+ DoubleToStr(cnt,0), OBJPROP_COLOR, Yellow);
}
//-------End of Draw Camarilla arrows

//------ Midpoints Pivots

if (midpivots==true)
{

ObjectCreate("M5 label"+ DoubleToStr(cnt,0), OBJ_TEXT, 0, sign_pos, M5);
ObjectSetText("M5 label"+ DoubleToStr(cnt,0), " M5", 8, "Arial", Blue);
ObjectCreate("M4 label"+ DoubleToStr(cnt,0), OBJ_TEXT, 0, sign_pos, M4);
ObjectSetText("M4 label"+ DoubleToStr(cnt,0), " M4", 8, "Arial", Blue);
ObjectCreate("M3 label"+ DoubleToStr(cnt,0), OBJ_TEXT, 0, sign_pos, M3);
ObjectSetText("M3 label"+ DoubleToStr(cnt,0), " M3", 8, "Arial", Blue);
ObjectCreate("M2 label"+ DoubleToStr(cnt,0), OBJ_TEXT, 0, sign_pos, M2);
ObjectSetText("M2 label"+ DoubleToStr(cnt,0), " M2", 8, "Arial", Blue);
ObjectCreate("M1 label"+ DoubleToStr(cnt,0), OBJ_TEXT, 0, sign_pos, M1);
ObjectSetText("M1 label"+ DoubleToStr(cnt,0), " M1", 8, "Arial", Blue);
ObjectCreate("M0 label"+ DoubleToStr(cnt,0), OBJ_TEXT, 0, sign_pos, M0);
ObjectSetText("M0 label"+ DoubleToStr(cnt,0), " M0", 8, "Arial", Blue);

//---- Draw Midpoint Pivots on Chart
ObjectCreate("M5 arrow"+ DoubleToStr(cnt,0), OBJ_ARROW, 0, sign_pos, M5);
ObjectSet("M5 arrow"+ DoubleToStr(cnt,0), OBJPROP_ARROWCODE, 6); 
ObjectSet("M5 arrow"+ DoubleToStr(cnt,0), OBJPROP_COLOR, Blue);
ObjectCreate("M4 arrow"+ DoubleToStr(cnt,0), OBJ_ARROW, 0, sign_pos, M4);
ObjectSet("M4 arrow"+ DoubleToStr(cnt,0), OBJPROP_ARROWCODE, 6); 
ObjectSet("M4 arrow"+ DoubleToStr(cnt,0), OBJPROP_COLOR, Blue);
ObjectCreate("M3 arrow"+ DoubleToStr(cnt,0), OBJ_ARROW, 0, sign_pos, M3);
ObjectSet("M3 arrow"+ DoubleToStr(cnt,0), OBJPROP_ARROWCODE, 6); 
ObjectSet("M3 arrow"+ DoubleToStr(cnt,0), OBJPROP_COLOR, Blue);
ObjectCreate("M2 arrow"+ DoubleToStr(cnt,0), OBJ_ARROW, 0, sign_pos, M2);
ObjectSet("M2 arrow"+ DoubleToStr(cnt,0), OBJPROP_ARROWCODE, 6); 
ObjectSet("M2 arrow"+ DoubleToStr(cnt,0), OBJPROP_COLOR, Blue);
ObjectCreate("M1 arrow"+ DoubleToStr(cnt,0), OBJ_ARROW, 0, sign_pos, M1);
ObjectSet("M1 arrow"+ DoubleToStr(cnt,0), OBJPROP_ARROWCODE, 6); 
ObjectSet("M1 arrow"+ DoubleToStr(cnt,0), OBJPROP_COLOR, Blue);
ObjectCreate("M0 arrow"+ DoubleToStr(cnt,0), OBJ_ARROW, 0, sign_pos, M0);
ObjectSet("M0 arrow"+ DoubleToStr(cnt,0), OBJPROP_ARROWCODE, 6); 
ObjectSet("M0 arrow"+ DoubleToStr(cnt,0), OBJPROP_COLOR, Blue);

}
}
}
//----End of Midpoint Pivots Draw

//---- End Of Program
return(0);
}
//+------------------------------------------------------------------+

